#!usr/bin/perl -w

use strict;

use XML::LibXML;
use XML::LibXML::SAX::Builder;

my %camelid_links = (
    one   => { url         => 'http://www.online.discovery.com/news/picture/may99/photo20.html',
               description => 'Bactrian Camel in front of Great Pyramids in Giza, Egypt.'},
    two   => { url         => 'http://www.fotos-online.de/english/m/09/9532.htm',
               description => 'Dromedary Camel illustrates the importance of accessorizing.'},
    three => { url         => 'http://www.eskimo.com/~wallama/funny.htm',
               description => 'Charlie - biography of a narcissistic llama.'},
    four  => { url         => 'http://arrow.colorado.edu/travels/other/turkey.html',
               description => 'A visual metaphor for the perl5-porters list?'},
    five  => { url         => 'http://www.galaonline.org/pics.htm',
               description => 'Many cool alpacas.'},
    six   => { url         => 'http://www.thpf.de/suedamerikareise/galerie/vicunas.htm',
               description => 'Wild Vicunas in a scenic landscape.'}
);

my $builder = XML::LibXML::SAX::Builder->new();
my $driver = CamelDriver->new(Handler => $builder);
my $doc = $driver->parse(%camelid_links);
print $doc->toString;

package CamelDriver;
use base qw(XML::SAX::Base);

sub parse {
    my $self = shift;
    my %links = @_;
    $self->SUPER::start_document;
    $self->SUPER::start_element({Name => 'html'});
    $self->SUPER::start_element({Name => 'body'});

foreach my $item (keys (%camelid_links)) {
    $self->SUPER::start_element({Name => 'a',
                                 Attributes => {
                                   'href' => $links{$item}->{url}
                                               }
                                });
    $self->SUPER::characters({Data =>  $links{$item}->{description}});
    $self->SUPER::end_element({Name => 'a'});
}

    $self->SUPER::end_element({Name => 'body'});
    $self->SUPER::end_element({Name => 'html'});
    $self->SUPER::end_document;

}

1;
