#!usr/bin/perl -w

use strict;
use XML::LibXML;

my %camelid_links = (
    one   => { url         => 'http://www.online.discovery.com/news/picture/may99/photo20.html',
               description => 'Bactrian Camel in front of Great Pyramids in Giza, Egypt.'},
    two   => { url         => 'http://www.fotos-online.de/english/m/09/9532.htm',
               description => 'Dromedary Camel illustrates the importance of accessorizing.'},
    three => { url         => 'http://www.eskimo.com/~wallama/funny.htm',
               description => 'Charlie - biography of a narcissistic llama.'},
    four  => { url         => 'http://arrow.colorado.edu/travels/other/turkey.html',
               description => 'A visual metaphor for the perl5-porters list?'},
    five  => { url         => 'http://www.galaonline.org/pics.htm',
               description => 'Many cool alpacas.'},
    six   => { url         => 'http://www.thpf.de/suedamerikareise/galerie/vicunas.htm',
               description => 'Wild Vicunas in a scenic landscape.'}
);

my $doc = XML::LibXML::Document->new();
my $root = XML::LibXML::Element->new('html');
$doc->setDocumentElement($root);
my $body = XML::LibXML::Element->new('body');
$root->appendChild($body);

foreach my $item (keys (%camelid_links)) {
    my $link = XML::LibXML::Element->new('a');
    $link->setAttribute('href', $camelid_links{$item}->{url});
    my $text = XML::LibXML::Text->new($camelid_links{$item}->{description});
    $link->appendChild($text);
    $body->appendChild($link);
}

print $doc->toString;
